## org.apache.lucene.index
Class IndexDeletionPolicy

    java.lang.Object
      org.apache.lucene.index.IndexDeletionPolicy

All Implemented Interfaces:
  Cloneable

Direct Known Subclasses:
  KeepOnlyLastCommitDeletionPolicy, NoDeletionPolicy, SnapshotDeletionPolicy

    public abstract class IndexDeletionPolicy

extends Object
implements Cloneable

Expert: policy for deletion of stale `index commits`.

Implement this interface, and pass it to one of the `IndexWriter` or `IndexReader` constructors, to customize when older `point-in-time commits` are deleted from the index directory. The default deletion policy is `KeepOnlyLastCommitDeletionPolicy`, which always removes old commits as soon as a new commit is done (this matches the behavior before 2.2).

One expected use case for this (and the reason why it was first created) is to work around problems with an index directory accessed via filesystems like NFS because NFS does not provide the "delete on last close" semantics that Lucene's "point in time" search normally relies on. By implementing a custom deletion policy, such as "a commit is only removed once it has been stale for more than X minutes", you can give your readers time to refresh to the new commit before `IndexWriter` removes the old commits. Note that doing so will increase the storage requirements of the index. See LUCENE-710 for details.

Implementers of sub-classes should make sure that `clone()` returns an independent instance able to work with any other `IndexWriter` or `Directory` instance.

Constructor Summary
`protected` `IndexDeletionPolicy()` Sole constructor, typically called by sub-classes constructors.

Method Summary
`IndexDeletionPolicy` `clone()`
`abstract void` `onCommit(List<? extends IndexCommit> commits)` This is called each time the writer completed a commit.
`abstract void` `onInit(List<? extends IndexCommit> commits)` This is called once when a writer is first instantiated to give the policy a chance to remove old commit points.

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### IndexDeletionPolicy

    protected IndexDeletionPolicy()

  Sole constructor, typically called by sub-classes constructors.

Method Detail

### onInit

    public abstract void onInit(List<? extends IndexCommit> commits)
                         throws IOException

  This is called once when a writer is first instantiated to give the policy a chance to remove old commit points.

  The writer locates all index commits present in the index directory and calls this method. The policy may choose to delete some of the commit points, doing so by calling method `delete()` of `IndexCommit`.

  Note: the last CommitPoint is the most recent one, i.e. the "front index state". Be careful not to delete it, unless you know for sure what you are doing, and unless you can afford to lose the index content while doing that.

  Parameters:
    `commits` - List of current `point-in-time commits`, sorted by age (the 0th one is the oldest commit). Note that for a new index this method is invoked with an empty list.
  Throws:
    `IOException`

### onCommit

    public abstract void onCommit(List<? extends IndexCommit> commits)
                           throws IOException

  This is called each time the writer completed a commit. This gives the policy a chance to remove old commit points with each commit.

  The policy may now choose to delete old commit points by calling method `delete()` of `IndexCommit`.

  This method is only called when `IndexWriter.commit()` or `IndexWriter.close()` is called, or possibly not at all if the `IndexWriter.rollback()` is called.

  Note: the last CommitPoint is the most recent one, i.e. the "front index state". Be careful not to delete it, unless you know for sure what you are doing, and unless you can afford to lose the index content while doing that.

  Parameters:
    `commits` - List of `IndexCommit`, sorted by age (the 0th one is the oldest commit).
  Throws:
    `IOException`

### clone

    public IndexDeletionPolicy clone()

  Overrides:
    `clone` in class `Object`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.